diff --git a/web/pgadmin/static/js/Explain/index.jsx b/web/pgadmin/static/js/Explain/index.jsx
new file mode 100644
index 000000000..f5845a9e8
--- /dev/null
+++ b/web/pgadmin/static/js/Explain/index.jsx
@@ -0,0 +1,487 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+import { Box, Tab, Tabs } from '@material-ui/core';
+import React from 'react';
+import _ from 'lodash';
+import Graphical from './Graphical';
+import TabPanel from '../components/TabPanel';
+import gettext  from 'sources/gettext';
+import ImageMapper from './ImageMapper';
+import { makeStyles } from '@material-ui/styles';
+import Analysis from './Analysis';
+import ExplainStatistics from './ExplainStatistics';
+import PropTypes from 'prop-types';
+import EmptyPanelMessage from '../components/EmptyPanelMessage';
+
+const useStyles = makeStyles((theme)=>({
+  tabPanel: {
+    padding: 0,
+    backgroundColor: theme.palette.background.default,
+  }
+}));
+
+// Some predefined constants used to calculate image location and its border
+var pWIDTH = 100.;
+var pHEIGHT = 100.;
+var offsetX = 200,
+  offsetY = 60;
+var xMargin = 25,
+  yMargin = 25;
+
+const DEFAULT_ARROW_SIZE = 2;
+
+function nodeExplainTableData(_planData, _ctx) {
+  let node_info,
+    display_text = [],
+    tooltip = [],
+    node_extra_info = [],
+    info = _ctx.explainTable;
+
+  // Display: <NODE>[ using <Index> ] [ on <Schema>.<Table>[ as <Alias>]]
+
+  if (/Scan/.test(_planData['Node Type'])) {
+    display_text.push(_planData['Node Type']);
+    tooltip.push(_planData['Node Type']);
+  } else {
+    display_text.push(_planData['image_text']);
+    tooltip.push(_planData['image_text']);
+  }
+  node_info = tooltip.join('');
+
+  if (typeof(_planData['Index Name']) !== 'undefined') {
+    display_text.push(' using ');
+    tooltip.push(' using ');
+    display_text.push(_.escape(_planData['Index Name']));
+    tooltip.push(_planData['Index Name']);
+  }
+
+  if (typeof(_planData['Relation Name']) !== 'undefined') {
+    display_text.push(' on ');
+    tooltip.push(' on ');
+    if (typeof(_planData['Schema']) !== 'undefined') {
+      display_text.push(_.escape(_planData['Schema']));
+      tooltip.push(_planData['Schema']);
+      display_text.push('.');
+      tooltip.push('.');
+    }
+    display_text.push(_.escape(_planData['Relation Name']));
+    tooltip.push(_planData['Relation Name']);
+
+    if (typeof(_planData['Alias']) !== 'undefined') {
+      display_text.push(' as ');
+      tooltip.push(' as ');
+      display_text.push(_.escape(_planData['Alias']));
+      tooltip.push(_.escape(_planData['Alias']));
+    }
+  }
+
+  if (
+    typeof(_planData['Plan Rows']) !== 'undefined' &&
+    typeof(_planData['Plan Width']) !== 'undefined'
+  ) {
+    let cost = [
+      ' (cost=',
+      (typeof(_planData['Startup Cost']) !== 'undefined' ?
+        _planData['Startup Cost'] : ''),
+      '..',
+      (typeof(_planData['Total Cost']) !== 'undefined' ?
+        _planData['Total Cost'] : ''),
+      ' rows=',
+      _planData['Plan Rows'],
+      ' width=',
+      _planData['Plan Width'],
+      ')',
+    ].join('');
+    display_text.push(cost);
+    tooltip.push(cost);
+  }
+
+  if (
+    typeof(_planData['Actual Startup Time']) !== 'undefined' ||
+    typeof(_planData['Actual Total Time']) !== 'undefined' ||
+    typeof(_planData['Actual Rows']) !== 'undefined'
+  ) {
+    let actual = [
+      ' (',
+      (typeof(_planData['Actual Startup Time']) !== 'undefined' ?
+        ('actual=' + _planData['Actual Startup Time']) + '..' : ''
+      ),
+      (typeof(_planData['Actual Total Time']) !== 'undefined' ?
+        _planData['Actual Total Time'] + ' ' : ''
+      ),
+      (typeof(_planData['Actual Rows']) !== 'undefined' ?
+        ('rows=' + _planData['Actual Rows']) : ''
+      ),
+      (typeof(_planData['Actual Loops']) !== 'undefined' ?
+        (' loops=' + _planData['Actual Loops']) : ''
+      ),
+      ')',
+    ].join('');
+
+    display_text.push(actual);
+    tooltip.push(actual);
+  }
+
+  if ('Join Filter' in _planData) {
+    node_extra_info.push(
+      '<strong>' + gettext('Join Filter') + '</strong>: ' + _.escape(_planData['Join Filter'])
+    );
+  }
+
+  if ('Filter' in _planData) {
+    node_extra_info.push('<strong>' + gettext('Filter') + '</strong>: ' + _.escape(_planData['Filter']));
+  }
+
+  if ('Index Cond' in _planData) {
+    node_extra_info.push('<strong>' + gettext('Index Cond') + '</strong>: ' + _.escape(_planData['Index Cond']));
+  }
+
+  if ('Hash Cond' in _planData) {
+    node_extra_info.push('<strong>' + gettext('Hash Cond') + '</strong>: ' + _.escape(_planData['Hash Cond']));
+  }
+
+  if ('Rows Removed by Filter' in _planData) {
+    node_extra_info.push(
+      '<strong>' + gettext('Rows Removed by Filter') + '</strong>: ' +
+        _.escape(_planData['Rows Removed by Filter'])
+    );
+  }
+
+  if ('Peak Memory Usage' in _planData) {
+    var buffer = [
+      '<strong>' + gettext('Buckets') + '</strong>:', _.escape(_planData['Hash Buckets']),
+      '<strong>' + gettext('Batches') + '</strong>:', _.escape(_planData['Hash Batches']),
+      '<strong>' + gettext('Memory Usage') + '</strong>:', _.escape(_planData['Peak Memory Usage']), 'kB',
+    ].join(' ');
+    node_extra_info.push(buffer);
+  }
+
+  if ('Recheck Cond' in _planData) {
+    node_extra_info.push('<strong>' + gettext('Recheck Cond') + '</strong>: ' + _planData['Recheck Cond']);
+  }
+
+  if ('Exact Heap Blocks' in _planData) {
+    node_extra_info.push('<strong>' + gettext('Heap Blocks') + '</strong>: exact=' + _planData['Exact Heap Blocks']);
+  }
+
+  info.rows.push({
+    data: _planData,
+    display_text: display_text.join(''),
+    tooltip_text: tooltip.join(''),
+    node_extra_info: node_extra_info,
+  });
+
+  if (typeof(_planData['exclusive_flag']) !== 'undefined') {
+    info.show_timings = true;
+  }
+
+  if (typeof(_planData['rowsx_flag']) !== 'undefined') {
+    info.show_rowsx = true;
+  }
+
+  if (typeof(_planData['Actual Loops']) !== 'undefined') {
+    info.show_rows = true;
+  }
+
+  if (typeof(_planData['Plan Rows']) !== 'undefined') {
+    info.show_plan_rows = true;
+  }
+
+  if (typeof(_planData['total_time']) !== 'undefined') {
+    info.total_time = _planData['total_time'];
+  }
+
+  let node;
+
+  if (typeof(_planData['Relation Name']) !== 'undefined') {
+    let relationName = (
+        typeof(_planData['Schema']) !== 'undefined' ?
+          (_planData['Schema'] + '.') : ''
+      ) + _planData['Relation Name'],
+      table = info.statistics.tables[relationName] || {
+        name: relationName,
+        count: 0,
+        sum_of_times: 0,
+        nodes: {},
+      };
+
+    node = table.nodes[node_info] || {
+      name: node_info,
+      count: 0,
+      sum_of_times: 0,
+    };
+
+    table.count++;
+    table.sum_of_times += _planData['exclusive'];
+    node.count++;
+    node.sum_of_times += _planData['exclusive'];
+
+    table.nodes[node_info] = node;
+    info.statistics.tables[relationName] = table;
+  }
+
+  node = info.statistics.nodes[node_info] || {
+    name: node_info,
+    count: 0,
+    sum_of_times: 0,
+  };
+
+  node.count++;
+  node.sum_of_times += _planData['exclusive'];
+  info.statistics.nodes[node_info] = node;
+}
+
+function parsePlan(data, ctx) {
+  var idx = 1,
+    lvl = data.level = data.level || [idx],
+    plans = [],
+    nodeType = data['Node Type'],
+    // Calculating relative xpos of current node from top node
+    xpos = data.xpos = data.xpos - pWIDTH,
+    // Calculating relative ypos of current node from top node
+    ypos = data.ypos,
+    maxChildWidth = 0;
+
+  ctx.totalNodes++;
+  ctx.explainTable.total_time = data['total_time'] || data['Actual Total Time'];
+
+  data['_serial'] = ctx.totalNodes;
+  data['width'] = pWIDTH;
+  data['height'] = pHEIGHT;
+
+  // Calculate arrow width according to cost of a particular plan
+  let arrowSize = DEFAULT_ARROW_SIZE;
+  let startCost = data['Startup Cost'],
+    totalCost = data['Total Cost'];
+  if (startCost != undefined && totalCost != undefined) {
+    arrowSize = Math.round(Math.log((startCost + totalCost) / 2 + startCost));
+    arrowSize = arrowSize < 1 ? 1 : arrowSize > 10 ? 10 : arrowSize;
+  }
+  data['arr_id'] = _.uniqueId('arr');
+  ctx.arrows[data['arr_id']] = arrowSize;
+  /*
+   * calculating xpos, ypos, width and height if current node is a subplan
+   */
+  if (data['Parent Relationship'] === 'SubPlan') {
+    data['width'] += (xMargin * 2) + (xMargin / 2);
+    data['height'] += (yMargin * 2);
+    data['ypos'] += yMargin;
+    xpos -= xMargin;
+    ypos += yMargin;
+  }
+
+  if (nodeType.startsWith('(slice'))
+    nodeType = nodeType.substring(0, 7);
+
+  // Get the image information for current node
+  var mappedImage = (_.isFunction(ImageMapper[nodeType]) &&
+      ImageMapper[nodeType].apply(undefined, [data])) ||
+    ImageMapper[nodeType] || {
+    'image': 'ex_unknown.svg',
+    'image_text': nodeType,
+  };
+
+  data['image'] = mappedImage['image'];
+  data['image_text'] = mappedImage['image_text'];
+
+  if ('Actual Total Time' in data && 'Actual Loops' in data) {
+    data['inclusive'] = Math.ceil10(
+      data['Actual Total Time'] * data['Actual Loops'], -3
+    );
+    data['exclusive'] = data['inclusive'];
+    data['inclusive_factor'] =  data['inclusive'] / (
+      data['total_time'] || data['Actual Total Time']
+    );
+    data['inclusive_flag'] = data['inclusive_factor'] <= 0.1 ? '1' :
+      data['inclusive_factor'] < 0.5 ? '2' :
+        data['inclusive_factor'] <= 0.9 ? '3' : '4';
+  }
+
+  if ('Actual Rows' in data && 'Plan Rows' in data) {
+    if (
+      data['Actual Rows'] === 0 || data['Actual Rows'] > data['Plan Rows']
+    ) {
+      data['rowsx'] = data['Plan Rows'] === 0 ? 0 :
+        (data['Actual Rows'] / data['Plan Rows']);
+      data['rowsx_direction'] = 'negative';
+    } else {
+      data['rowsx'] = data['Actual Rows'] === 0 ? 0 : (
+        data['Plan Rows'] / data['Actual Rows']
+      );
+      data['rowsx_direction'] = 'positive';
+    }
+    data['rowsx_flag'] = data['rowsx'] <= 10 ? '1' : (
+      data['rowsx'] <= 100 ? '2' : (data['rowsx'] <= 1000 ? '3' : '4')
+    );
+    data['rowsx'] = Math.ceil10(data['rowsx'], -2);
+  }
+
+  // Start calculating xpos, ypos, width and height for child plans if any
+  if ('Plans' in data) {
+    data['width'] += offsetX;
+
+    data['Plans'].forEach(function(p) {
+      let level = _.clone(lvl);
+      level.push(idx);
+
+      let plan = parsePlan({
+        ...p,
+        'level': level,
+        xpos: xpos - offsetX,
+        ypos: ypos,
+        total_time: data['total_time'] || data['Actual Total Time'],
+        parent_node: lvl.join('_'),
+      }, ctx);
+
+      if (maxChildWidth < plan.width) {
+        maxChildWidth = plan.width;
+      }
+
+      if ('exclusive' in data) {
+        if (plan.inclusive) {
+          data['exclusive'] -= plan.inclusive;
+        }
+      }
+
+      var childHeight = plan.height;
+
+      if (idx !== 1) {
+        data['height'] = data['height'] + childHeight + offsetY;
+      } else if (childHeight > data['height']) {
+        data['height'] = childHeight;
+      }
+      ypos += childHeight + offsetY;
+
+      plans.push(plan);
+      idx++;
+    });
+  }
+
+  if ('exclusive' in data) {
+    data['exclusive'] = Math.ceil10(data['exclusive'], -3);
+    data['exclusive_factor'] = (
+      data['exclusive'] / (data['total_time'] || data['Actual Total Time'])
+    );
+    data['exclusive_flag'] = data['exclusive_factor'] <= 0.1 ? '1' :
+      data['exclusive_factor'] < 0.5 ? '2' :
+        data['exclusive_factor'] <= 0.9 ? '3' : '4';
+  }
+
+  // Final Width and Height of current node
+  data['width'] += maxChildWidth;
+  data['Plans'] = plans;
+  nodeExplainTableData(data, ctx);
+
+  return data;
+}
+
+function parsePlanData(data, ctx) {
+  let retPlan = {};
+  if(data) {
+    if ('Plan' in data) {
+      let plan = parsePlan({
+        ...data['Plan'],
+        xpos: 0,
+        ypos: 0,
+      }, ctx);
+      retPlan['Plan'] = plan;
+      retPlan['xpos'] = 0;
+      retPlan['ypos'] = 0;
+      retPlan['width'] = plan.width + (xMargin * 2);
+      retPlan['height'] = plan.height + (yMargin * 4);
+    }
+
+    retPlan['Statistics'] = {
+      'JIT': [],
+      'Triggers': [],
+      'Summary': {},
+    };
+    if (data && 'JIT' in data) {
+      retPlan['Statistics']['JIT'] = retPlan['JIT'];
+    }
+    if (data && 'Triggers' in data) {
+      retPlan['Statistics']['Triggers'] = retPlan['JITriggersT'];
+    }
+    if(data) {
+      let summKeys = ['Planning Time', 'Execution Time'],
+        summary = {};
+
+      summKeys.forEach((key)=>{
+        if (key in data) {
+          summary[key] = data[key];
+        }
+      });
+
+      retPlan['Statistics']['Summary'] = summary;
+    }
+    if (data && 'Settings' in data) {
+      retPlan['Statistics']['Settings'] = data['Settings'];
+    }
+  }
+  return retPlan;
+}
+
+export default function Explain({plans=[]}) {
+  const classes = useStyles();
+  const [tabValue, setTabValue] = React.useState(0);
+
+  let ctx = React.useRef({
+    totalNodes: 0,
+    totalDownloadedNodes: 0,
+    isDownloaded: 0,
+    explainTable: {
+      rows: [],
+      statistics: {
+        tables: {},
+        nodes: {},
+      },
+    },
+    arrows: {},
+  });
+  let planData = React.useMemo(()=>(plans && parsePlanData(plans[0], ctx.current)), [plans]);
+
+  if(_.isEmpty(plans)) {
+    return <Box height="100%" display="flex" flexDirection="column">
+      <EmptyPanelMessage text={gettext('Use Explain/Explain analyze button to generate the plan for a query. Alternatively, you can also execute "EXPLAIN (FORMAT JSON) [QUERY]".')} />
+    </Box>;
+  }
+  return (
+    <Box height="100%" display="flex" flexDirection="column">
+      <Box>
+        <Tabs
+          value={tabValue}
+          onChange={(_e, selTabValue) => {
+            setTabValue(selTabValue);
+          }}
+          // indicatorColor="primary"
+          variant="scrollable"
+          scrollButtons="auto"
+          action={(ref)=>ref && ref.updateIndicator()}
+        >
+          <Tab label="Graphical" />
+          <Tab label="Analysis" />
+          <Tab label="Statistics" />
+        </Tabs>
+      </Box>
+      <TabPanel value={tabValue} index={0} classNameRoot={classes.tabPanel}>
+        <Graphical planData={planData} ctx={ctx.current}/>
+      </TabPanel>
+      <TabPanel value={tabValue} index={1} classNameRoot={classes.tabPanel}>
+        <Analysis explainTable={ctx.current.explainTable} />
+      </TabPanel>
+      <TabPanel value={tabValue} index={2} classNameRoot={classes.tabPanel}>
+        <ExplainStatistics explainTable={ctx.current.explainTable} />
+      </TabPanel>
+    </Box>
+  );
+}
+
+Explain.propTypes = {
+  plans: PropTypes.array,
+};
diff --git a/web/pgadmin/static/js/Explain/svg_download.js b/web/pgadmin/static/js/Explain/svg_download.js
new file mode 100644
index 000000000..5f70f8183
--- /dev/null
+++ b/web/pgadmin/static/js/Explain/svg_download.js
@@ -0,0 +1,54 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+import getApiInstance from '../api_instance';
+
+function convertImageURLtoDataURI(api, image) {
+  return new Promise(function(resolve, reject) {
+    let href = image.getAttribute('href') || image.getAttributeNS('http://www.w3.org/1999/xlink', 'href');
+    api.get(href).then(({data})=>{
+      image.setAttribute('href', 'data:image/svg+xml;base64,'+window.btoa(data));
+      resolve();
+    }).catch(()=>{
+      reject();
+    });
+  });
+}
+
+export function downloadSvg(svg, svgName) {
+  let svgDiv = document.createElement('div');
+  svgDiv.innerHTML = svg;
+  svgDiv.style.visibility = 'hidden';
+  svgDiv.style.display = 'table';
+  svgDiv.style.position = 'absolute';
+  let svgElement = svgDiv.firstChild;
+  let api = getApiInstance();
+  if (!svgElement) { return; }
+
+  let images = svgElement.getElementsByTagName('image');
+  let image_promises = [];
+  if (images){
+    for (let image of images) {
+      if ((image.getAttribute('href') && image.getAttribute('href').indexOf('data:') === -1)
+      || (image.getAttribute('xlink:href') && image.getAttribute('xlink:href').indexOf('data:') === -1)) {
+        image_promises.push(convertImageURLtoDataURI(api, image));
+      }
+    }
+  }
+
+  Promise.all(image_promises).then(function() {
+    let blob = new Blob([svgElement.outerHTML], {type: 'image/svg+xml'});
+    let svgURL = (window.URL || window.webkitURL).createObjectURL(blob);
+    let newElement = document.createElement('a');
+    newElement.href = svgURL;
+    newElement.setAttribute('download', svgName);
+    document.body.appendChild(newElement);
+    newElement.click();
+    document.body.removeChild(newElement);
+  });
+}
diff --git a/web/pgadmin/static/js/SchemaView/FormView.jsx b/web/pgadmin/static/js/SchemaView/FormView.jsx
index 684390d7f..7f0d988ed 100644
--- a/web/pgadmin/static/js/SchemaView/FormView.jsx
+++ b/web/pgadmin/static/js/SchemaView/FormView.jsx
@@ -187,8 +187,8 @@ export default function FormView({
           if(_.isArray(dep)) {
             source = dep;
           }
-          if(field.depChange) {
-            depListener.addDepListener(source, accessPath.concat(field.id), field.depChange);
+          if(field.depChange || field.deferredDepChange) {
+            depListener.addDepListener(source, accessPath.concat(field.id), field.depChange, field.deferredDepChange);
           }
           if(field.depChange || field.deferredDepChange) {
             depListener.addDepListener(source, accessPath.concat(field.id), field.depChange, field.deferredDepChange);
diff --git a/web/pgadmin/static/js/SchemaView/index.jsx b/web/pgadmin/static/js/SchemaView/index.jsx
index ec6df7d17..3b85c67a0 100644
--- a/web/pgadmin/static/js/SchemaView/index.jsx
+++ b/web/pgadmin/static/js/SchemaView/index.jsx
@@ -429,7 +429,7 @@ function prepareData(val, createMode=false) {
 
 /* If its the dialog */
 function SchemaDialogView({
-  getInitData, viewHelperProps, schema={}, showFooter=true, isTabView=true, ...props}) {
+  getInitData, viewHelperProps, loadingText, schema={}, showFooter=true, isTabView=true, ...props}) {
   const classes = useDialogStyles();
   /* Some useful states */
   const [dirty, setDirty] = useState(false);
@@ -704,7 +704,7 @@ function SchemaDialogView({
       <DepListenerContext.Provider value={depListenerObj.current}>
         <Box className={classes.root}>
           <Box className={classes.form}>
-            <Loader message={loaderText}/>
+            <Loader message={loaderText || loadingText}/>
             <FormView value={sessData} viewHelperProps={viewHelperProps}
               schema={schema} accessPath={[]} dataDispatch={sessDispatchWithListener}
               hasSQLTab={props.hasSQL} getSQLValue={getSQLValue} firstEleRef={firstEleRef} isTabView={isTabView} className={props.formClassName} />
@@ -746,6 +746,7 @@ SchemaDialogView.propTypes = {
     }),
     inCatalog: PropTypes.bool,
   }).isRequired,
+  loadingText: PropTypes.string,
   schema: CustomPropTypes.schemaUI,
   onSave: PropTypes.func,
   onClose: PropTypes.func,
diff --git a/web/pgadmin/static/js/Theme/dark.js b/web/pgadmin/static/js/Theme/dark.js
index 617af6753..36ccb69ca 100644
--- a/web/pgadmin/static/js/Theme/dark.js
+++ b/web/pgadmin/static/js/Theme/dark.js
@@ -22,7 +22,7 @@ export default function(basicSettings) {
         disabledContrastText: '#fff',
         hoverMain: '#303030',
         hoverContrastText: '#fff',
-        hoverBorderColor: '#2e2e2e',
+        hoverBorderColor: '#151515',
       },
       primary: {
         main: '#234d6e',
@@ -73,7 +73,7 @@ export default function(basicSettings) {
       icon: {
         main: '#6b6b6b',
         contrastText: '#fff',
-        borderColor: '#2e2e2e',
+        borderColor: darken('#2e2e2e', 0.6),
         disabledMain: '#6b6b6b',
         disabledContrastText: '#fff',
         disabledBorderColor: '#2e2e2e',
@@ -86,6 +86,7 @@ export default function(basicSettings) {
       inputBorderColor: '#6b6b6b',
       inputDisabledBg: 'inherit',
       headerBg: '#424242',
+      activeBorder: '#d4d4d4',
       activeColor: '#d4d4d4',
       tableBg: '#424242',
       activeStepBg: '#234d6e',
@@ -93,6 +94,11 @@ export default function(basicSettings) {
       stepBg: '#FFFFFF',
       stepFg: '#000',
       toggleBtnBg: '#000',
+      editorToolbarBg: '#303030',
+      qtDatagridBg: '#2e2e2e',
+      qtDatagridSelectFg: '#d4d4d4',
+      cardHeaderBg: '#424242',
+      colorFg: '#FFFFFF',
       emptySpaceBg: '#212121',
     }
   });
diff --git a/web/pgadmin/static/js/Theme/high_contrast.js b/web/pgadmin/static/js/Theme/high_contrast.js
index c9d0af429..338f1ccb6 100644
--- a/web/pgadmin/static/js/Theme/high_contrast.js
+++ b/web/pgadmin/static/js/Theme/high_contrast.js
@@ -80,17 +80,23 @@ export default function(basicSettings) {
       }
     },
     otherVars: {
-      borderColor: '#4a4a4a',
+      borderColor: '#A6B7C8',
       inputBorderColor: '#6b6b6b',
       inputDisabledBg: '#1F2932',
       headerBg: '#010B15',
-      activeColor: '#d4d4d4',
+      activeBorder: '#fff',
+      activeColor: '#fff',
       tableBg: '#010B15',
       activeStepBg: '#84D6FF',
       activeStepFg: '#010b15',
       stepBg: '#FFFFFF',
       stepFg: '#000',
       toggleBtnBg: '#6B6B6B',
+      editorToolbarBg: '#010B15',
+      qtDatagridBg: '#010B15',
+      qtDatagridSelectFg: '#010B15',
+      cardHeaderBg: '#062F57',
+      colorFg: '#FFFFFF',
       emptySpaceBg: '#010B15',
     }
   });
diff --git a/web/pgadmin/static/js/Theme/index.jsx b/web/pgadmin/static/js/Theme/index.jsx
index d2a070f15..9124743ec 100644
--- a/web/pgadmin/static/js/Theme/index.jsx
+++ b/web/pgadmin/static/js/Theme/index.jsx
@@ -81,7 +81,7 @@ basicSettings = createMuiTheme(basicSettings, {
           height: '28px',
           fontSize: '0.875rem',
           '& .MuiSvgIcon-root': {
-            height: '0.8em',
+            height: '1.2rem',
           }
         },
       },
@@ -167,13 +167,17 @@ basicSettings = createMuiTheme(basicSettings, {
     MuiDialog: {
       paper: {
         margin: 0,
+      },
+      scrollPaper: {
+        alignItems: 'flex-start',
+        margin: '5% auto',
       }
     },
     MuiTooltip: {
       popper: {
         top: 0,
         zIndex: 9999,
-      }
+      },
     },
     MuiMenu: {
       list: {
@@ -231,6 +235,9 @@ basicSettings = createMuiTheme(basicSettings, {
     MuiListItem: {
       disableGutters: true,
     },
+    MuiTooltip: {
+      arrow: true,
+    }
   },
 });
 
@@ -460,6 +467,7 @@ function getFinalTheme(baseTheme) {
       MuiCardHeader: {
         root: {
           padding: '4px 8px',
+          backgroundColor: baseTheme.otherVars.cardHeaderBg,
           ...mixins.panelBorder.bottom,
         }
       },
@@ -487,11 +495,22 @@ function getFinalTheme(baseTheme) {
           '&$selected': {
             backgroundColor: baseTheme.palette.primary.light,
             borderColor: baseTheme.palette.primary.main,
+            color: basicSettings.palette.getContrastText(baseTheme.palette.primary.light),
             '&:hover': {
               backgroundColor: baseTheme.palette.primary.light,
             }
           },
         }
+      },
+      MuiTooltip: {
+        tooltip: {
+          fontSize: '0.7rem',
+          color: baseTheme.palette.background.default,
+          backgroundColor: baseTheme.palette.text.primary,
+        },
+        arrow: {
+          color: baseTheme.palette.text.primary,
+        }
       }
     }
   }, baseTheme);
diff --git a/web/pgadmin/static/js/Theme/standard.js b/web/pgadmin/static/js/Theme/standard.js
index 998429f00..1efe55300 100644
--- a/web/pgadmin/static/js/Theme/standard.js
+++ b/web/pgadmin/static/js/Theme/standard.js
@@ -101,7 +101,9 @@ export default function(basicSettings) {
       stepFg: '#000',
       toggleBtnBg: '#000',
       editorToolbarBg: '#ebeef3',
-      datagridBg: '#fff',
+      qtDatagridBg: '#fff',
+      qtDatagridSelectFg: '#222',
+      cardHeaderBg: '#fff',
       emptySpaceBg: '#ebeef3',
     }
   });
diff --git a/web/pgadmin/static/js/api_instance.js b/web/pgadmin/static/js/api_instance.js
index c6ce38cb1..4a4c65467 100644
--- a/web/pgadmin/static/js/api_instance.js
+++ b/web/pgadmin/static/js/api_instance.js
@@ -29,7 +29,7 @@ export function parseApiError(error) {
     // The request was made and the server responded with a status code
     // that falls out of the range of 2xx
     if(error.response.headers['content-type'] == 'application/json') {
-      return `INTERNAL SERVER ERROR: ${error.response.data.errormsg}`;
+      return error.response.data.errormsg;
     } else {
       return error.response.statusText;
     }
diff --git a/web/pgadmin/static/js/clipboard.js b/web/pgadmin/static/js/clipboard.js
new file mode 100644
index 000000000..747c4444e
--- /dev/null
+++ b/web/pgadmin/static/js/clipboard.js
@@ -0,0 +1,13 @@
+export function copyToClipboard(text) {
+  try {
+    navigator.clipboard.writeText(text);
+  } catch {
+    /* Suppress error */
+    console.error('Does not have clipboard acccess');
+  }
+  localStorage.setItem('clipboard', text);
+}
+
+export function getFromClipboard() {
+  return localStorage.getItem('clipboard');
+}
diff --git a/web/pgadmin/static/js/components/Buttons.jsx b/web/pgadmin/static/js/components/Buttons.jsx
index 3eaf7c155..ae20f1045 100644
--- a/web/pgadmin/static/js/components/Buttons.jsx
+++ b/web/pgadmin/static/js/components/Buttons.jsx
@@ -42,6 +42,7 @@ const useStyles = makeStyles((theme)=>({
     }
   },
   iconButton: {
+    minWidth: 0,
     padding: '3px 6px',
     '&.MuiButton-sizeSmall, &.MuiButton-outlinedSizeSmall, &.MuiButton-containedSizeSmall': {
       padding: '1px 4px',
@@ -59,6 +60,7 @@ const useStyles = makeStyles((theme)=>({
     '&:hover': {
       backgroundColor: theme.custom.icon.hoverMain,
       color: theme.custom.icon.hoverContrastText,
+      borderColor: theme.custom.icon.borderColor,
     },
   },
   splitButton: {
@@ -72,6 +74,7 @@ const useStyles = makeStyles((theme)=>({
   xsButton: {
     padding: '2px 1px',
     height: '24px',
+    minWidth: '24px',
     '& .MuiSvgIcon-root': {
       height: '0.8em',
     }
@@ -127,27 +130,29 @@ DefaultButton.propTypes = {
 
 
 /* pgAdmin Icon button, takes Icon component as input */
-export const PgIconButton = forwardRef(({icon, title, shortcut, accessKey, className, splitButton, style, color, ...props}, ref)=>{
+export const PgIconButton = forwardRef(({icon, title, shortcut, className, splitButton, style, color, accesskey, ...props}, ref)=>{
   const classes = useStyles();
 
   let shortcutTitle = null;
-  if(accessKey || shortcut) {
-    shortcutTitle = <ShortcutTitle title={title} accessKey={accessKey} shortcut={shortcut}/>;
+  if(accesskey || shortcut) {
+    shortcutTitle = <ShortcutTitle title={title} accesskey={accesskey} shortcut={shortcut}/>;
   }
 
   /* Tooltip does not work for disabled items */
   if(props.disabled) {
     if(color == 'primary') {
       return (
-        <PrimaryButton ref={ref} style={{minWidth: 0, ...style}}
-          className={clsx(classes.iconButton, (splitButton ? classes.splitButton : ''), className)} {...props}>
+        <PrimaryButton ref={ref} style={style}
+          className={clsx(classes.iconButton, (splitButton ? classes.splitButton : ''), className)}
+          accessKey={accesskey} {...props}>
           {icon}
         </PrimaryButton>
       );
     } else {
       return (
-        <DefaultButton ref={ref} style={{minWidth: 0, ...style}}
-          className={clsx(classes.iconButton, classes.iconButtonDefault, (splitButton ? classes.splitButton : ''), className)} {...props}>
+        <DefaultButton ref={ref} style={style}
+          className={clsx(classes.iconButton, classes.iconButtonDefault, (splitButton ? classes.splitButton : ''), className)}
+          accessKey={accesskey} {...props}>
           {icon}
         </DefaultButton>
       );
@@ -156,8 +161,9 @@ export const PgIconButton = forwardRef(({icon, title, shortcut, accessKey, class
     if(color == 'primary') {
       return (
         <Tooltip title={shortcutTitle || title || ''} aria-label={title || ''}>
-          <PrimaryButton ref={ref} style={{minWidth: 0, ...style}}
-            className={clsx(classes.iconButton, (splitButton ? classes.splitButton : ''), className)} {...props}>
+          <PrimaryButton ref={ref} style={style}
+            className={clsx(classes.iconButton, (splitButton ? classes.splitButton : ''), className)}
+            accessKey={accesskey} {...props}>
             {icon}
           </PrimaryButton>
         </Tooltip>
@@ -165,8 +171,9 @@ export const PgIconButton = forwardRef(({icon, title, shortcut, accessKey, class
     } else {
       return (
         <Tooltip title={shortcutTitle || title || ''} aria-label={title || ''}>
-          <DefaultButton ref={ref} style={{minWidth: 0, ...style}}
-            className={clsx(classes.iconButton, classes.iconButtonDefault, (splitButton ? classes.splitButton : ''), className)} {...props}>
+          <DefaultButton ref={ref} style={style}
+            className={clsx(classes.iconButton, classes.iconButtonDefault, (splitButton ? classes.splitButton : ''), className)}
+            accessKey={accesskey} {...props}>
             {icon}
           </DefaultButton>
         </Tooltip>
@@ -179,7 +186,7 @@ PgIconButton.propTypes = {
   icon: CustomPropTypes.children,
   title: PropTypes.string.isRequired,
   shortcut: CustomPropTypes.shortcut,
-  accessKey: PropTypes.string,
+  accesskey: PropTypes.string,
   className: PropTypes.oneOfType([PropTypes.string, PropTypes.object]),
   style: PropTypes.object,
   color: PropTypes.oneOf(['primary', 'default', undefined]),
